import{S as en,i as tn,s as an,e as s,k as m,w as g,t as r,M as nn,c as o,d as t,m as c,a as i,x as q,h as l,b as u,G as a,g as p,y as z,q as v,o as $,B as j,v as sn}from"../../../chunks/vendor-hf-doc-builder.js";import{T as Za}from"../../../chunks/Tip-hf-doc-builder.js";import{I as Be}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as me}from"../../../chunks/CodeBlock-hf-doc-builder.js";function on(ce){let d,T,f,h,Q,_,H,E;return{c(){d=s("p"),T=r("You can read the "),f=s("a"),h=r("conceptual guide on quantization"),Q=r(` to learn about quantization. It
explains the main concepts that you will be using when performing quantization with the
`),_=s("a"),H=r("ORTQuantizer"),E=r("."),this.h()},l(S){d=o(S,"P",{});var y=i(d);T=l(y,"You can read the "),f=o(y,"A",{href:!0});var w=i(f);h=l(w,"conceptual guide on quantization"),w.forEach(t),Q=l(y,` to learn about quantization. It
explains the main concepts that you will be using when performing quantization with the
`),_=o(y,"A",{href:!0});var de=i(_);H=l(de,"ORTQuantizer"),de.forEach(t),E=l(y,"."),y.forEach(t),this.h()},h(){u(f,"href","/concept_guides/quantization"),u(_,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer")},m(S,y){p(S,d,y),a(d,T),a(d,f),a(f,h),a(d,Q),a(d,_),a(_,H),a(d,E)},d(S){S&&t(d)}}}function rn(ce){let d,T;return{c(){d=s("p"),T=r("Currently, only dynamic quantization is supported for Seq2Seq models.")},l(f){d=o(f,"P",{});var h=i(d);T=l(h,"Currently, only dynamic quantization is supported for Seq2Seq models."),h.forEach(t)},m(f,h){p(f,d,h),a(d,T)},d(f){f&&t(d)}}}function ln(ce){let d,T,f,h,Q,_,H,E,S,y,w,de,Re,yt,wt,U,Tt,Ot,Ge,O,bt,fe,xt,kt,he,Rt,Qt,Ye,F,Je,C,L,Qe,B,Et,_e,St,Ee,Ct,Ke,b,At,ge,Nt,Mt,Se,Ft,Lt,Ve,qe,G,Pt,Ce,Xt,Dt,We,Y,Ze,J,Ae,It,et,K,tt,A,P,Ne,V,Ht,Me,Ut,at,x,Bt,ze,Gt,Yt,W,Jt,Kt,nt,Z,st,N,X,Fe,ee,Vt,Le,Wt,ot,k,Zt,ve,ea,ta,te,aa,na,it,ae,rt,M,D,Pe,ne,sa,Xe,oa,lt,R,ia,$e,ra,la,je,pa,ua,pt,I,ut,ye,se,ma,De,ca,da,mt,oe,ct,ie,Ie,fa,dt,re,ft,le,He,ha,ht,pe,_t;return _=new Be({}),F=new Za({props:{$$slots:{default:[on]},$$scope:{ctx:ce}}}),B=new Be({}),Y=new me({props:{code:`from optimum.onnxruntime import ORTQuantizer, ORTModelForSequenceClassification

ort_model = ORTModelForSequenceClassification.from_pretrained(
    "optimum/distilbert-base-uncased-finetuned-sst-2-english"
)

quantizer = ORTQuantizer.from_pretrained(ort_model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer, ORTModelForSequenceClassification

<span class="hljs-comment"># Loading ONNX Model from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>ort_model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;optimum/distilbert-base-uncased-finetuned-sst-2-english&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-comment"># Create a quantizer from a ORTModelForXXX</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>quantizer = ORTQuantizer.from_pretrained(ort_model)`}}),K=new me({props:{code:`from optimum.onnxruntime import ORTQuantizer

quantizer = ORTQuantizer.from_pretrained("path/to/model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer

<span class="hljs-comment"># This assumes a model.onnx exists in path/to/model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>quantizer = ORTQuantizer.from_pretrained(<span class="hljs-string">&quot;path/to/model&quot;</span>)`}}),V=new Be({}),Z=new me({props:{code:`from optimum.onnxruntime import ORTQuantizer, ORTModelForSequenceClassification
from optimum.onnxruntime.configuration import AutoQuantizationConfig

onnx_model = ORTModelForSequenceClassification.from_pretrained("distilbert-base-uncased-finetuned-sst-2-english", from_transformers=True)

quantizer = ORTQuantizer.from_pretrained(onnx_model)

dqconfig = AutoQuantizationConfig.avx512_vnni(is_static=False, per_channel=False)

model_quantized_path = quantizer.quantize(
    save_dir="path/to/output/model",
    quantization_config=dqconfig,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer, ORTModelForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime.configuration <span class="hljs-keyword">import</span> AutoQuantizationConfig

<span class="hljs-comment"># Load PyTorch model and convert to ONNX</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_model = ORTModelForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>, from_transformers=<span class="hljs-literal">True</span>)

<span class="hljs-comment"># Create quantizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>quantizer = ORTQuantizer.from_pretrained(onnx_model)

<span class="hljs-comment"># Define the quantization strategy by creating the appropriate configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dqconfig = AutoQuantizationConfig.avx512_vnni(is_static=<span class="hljs-literal">False</span>, per_channel=<span class="hljs-literal">False</span>)

<span class="hljs-comment"># Quantize the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_quantized_path = quantizer.quantize(
<span class="hljs-meta">... </span>    save_dir=<span class="hljs-string">&quot;path/to/output/model&quot;</span>,
<span class="hljs-meta">... </span>    quantization_config=dqconfig,
<span class="hljs-meta">... </span>)`}}),ee=new Be({}),ae=new me({props:{code:`from functools import partial
from transformers import AutoTokenizer
from optimum.onnxruntime import ORTQuantizer, ORTModelForSequenceClassification
from optimum.onnxruntime.configuration import AutoQuantizationConfig, AutoCalibrationConfig

model_id = "distilbert-base-uncased-finetuned-sst-2-english"

onnx_model = ORTModelForSequenceClassification.from_pretrained(model_id, from_transformers=True)
tokenizer = AutoTokenizer.from_pretrained(model_id)
quantizer = ORTQuantizer.from_pretrained(onnx_model)
qconfig = AutoQuantizationConfig.arm64(is_static=True, per_channel=False)

def preprocess_fn(ex, tokenizer):
    return tokenizer(ex["sentence"])

calibration_dataset = quantizer.get_calibration_dataset(
    "glue",
    dataset_config_name="sst2",
    preprocess_function=partial(preprocess_fn, tokenizer=tokenizer),
    num_samples=50,
    dataset_split="train",
)

calibration_config = AutoCalibrationConfig.minmax(calibration_dataset)

ranges = quantizer.fit(
    dataset=calibration_dataset,
    calibration_config=calibration_config,
    operators_to_quantize=qconfig.operators_to_quantize,
)

model_quantized_path = quantizer.quantize(
    save_dir="path/to/output/model",
    calibration_tensors_range=ranges,
    quantization_config=qconfig,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> functools <span class="hljs-keyword">import</span> partial
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer, ORTModelForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime.configuration <span class="hljs-keyword">import</span> AutoQuantizationConfig, AutoCalibrationConfig

<span class="hljs-meta">&gt;&gt;&gt; </span>model_id = <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>

<span class="hljs-comment"># Load PyTorch model and convert to ONNX and create Quantizer and setup config</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_model = ORTModelForSequenceClassification.from_pretrained(model_id, from_transformers=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(model_id)
<span class="hljs-meta">&gt;&gt;&gt; </span>quantizer = ORTQuantizer.from_pretrained(onnx_model)
<span class="hljs-meta">&gt;&gt;&gt; </span>qconfig = AutoQuantizationConfig.arm64(is_static=<span class="hljs-literal">True</span>, per_channel=<span class="hljs-literal">False</span>)

<span class="hljs-comment"># Create the calibration dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">preprocess_fn</span>(<span class="hljs-params">ex, tokenizer</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> tokenizer(ex[<span class="hljs-string">&quot;sentence&quot;</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>calibration_dataset = quantizer.get_calibration_dataset(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;glue&quot;</span>,
<span class="hljs-meta">... </span>    dataset_config_name=<span class="hljs-string">&quot;sst2&quot;</span>,
<span class="hljs-meta">... </span>    preprocess_function=partial(preprocess_fn, tokenizer=tokenizer),
<span class="hljs-meta">... </span>    num_samples=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    dataset_split=<span class="hljs-string">&quot;train&quot;</span>,
<span class="hljs-meta">... </span>)

<span class="hljs-comment"># Create the calibration configuration containing the parameters related to calibration.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>calibration_config = AutoCalibrationConfig.minmax(calibration_dataset)

<span class="hljs-comment"># Perform the calibration step: computes the activations quantization ranges</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>ranges = quantizer.fit(
<span class="hljs-meta">... </span>    dataset=calibration_dataset,
<span class="hljs-meta">... </span>    calibration_config=calibration_config,
<span class="hljs-meta">... </span>    operators_to_quantize=qconfig.operators_to_quantize,
<span class="hljs-meta">... </span>)

<span class="hljs-comment"># Apply static quantization on the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_quantized_path = quantizer.quantize(
<span class="hljs-meta">... </span>    save_dir=<span class="hljs-string">&quot;path/to/output/model&quot;</span>,
<span class="hljs-meta">... </span>    calibration_tensors_range=ranges,
<span class="hljs-meta">... </span>    quantization_config=qconfig,
<span class="hljs-meta">... </span>)`}}),ne=new Be({}),I=new Za({props:{warning:!0,$$slots:{default:[rn]},$$scope:{ctx:ce}}}),oe=new me({props:{code:`from optimum.onnxruntime import ORTQuantizer, ORTModelForSeq2SeqLM
from optimum.onnxruntime.configuration import AutoQuantizationConfig

model_id = "optimum/t5-small"
onnx_model = ORTModelForSeq2SeqLM.from_pretrained(model_id)
model_dir = onnx_model.model_save_dir`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer, ORTModelForSeq2SeqLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime.configuration <span class="hljs-keyword">import</span> AutoQuantizationConfig

<span class="hljs-comment"># load Seq2Seq model and set model file directory</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_id = <span class="hljs-string">&quot;optimum/t5-small&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_model = ORTModelForSeq2SeqLM.from_pretrained(model_id)
<span class="hljs-meta">&gt;&gt;&gt; </span>model_dir = onnx_model.model_save_dir`}}),re=new me({props:{code:`encoder_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name="encoder_model.onnx")

decoder_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name="decoder_model.onnx")

decoder_wp_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name="decoder_with_past_model.onnx")

quantizer = [encoder_quantizer, decoder_quantizer, decoder_wp_quantizer]`,highlighted:`<span class="hljs-comment"># Create encoder quantizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name=<span class="hljs-string">&quot;encoder_model.onnx&quot;</span>)

<span class="hljs-comment"># Create decoder quantizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name=<span class="hljs-string">&quot;decoder_model.onnx&quot;</span>)

<span class="hljs-comment"># Create decoder with past key values quantizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_wp_quantizer = ORTQuantizer.from_pretrained(model_dir, file_name=<span class="hljs-string">&quot;decoder_with_past_model.onnx&quot;</span>)

<span class="hljs-comment"># Create Quantizer list</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>quantizer = [encoder_quantizer, decoder_quantizer, decoder_wp_quantizer]`}}),pe=new me({props:{code:`dqconfig = AutoQuantizationConfig.avx512_vnni(is_static=False, per_channel=False)

for q in quantizer:
    q.quantize(save_dir=".",quantization_config=dqconfig)  # doctest: +IGNORE_RESULT`,highlighted:`<span class="hljs-comment"># Define the quantization strategy by creating the appropriate configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dqconfig = AutoQuantizationConfig.avx512_vnni(is_static=<span class="hljs-literal">False</span>, per_channel=<span class="hljs-literal">False</span>)

<span class="hljs-comment"># Quantize the models individually</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> q <span class="hljs-keyword">in</span> quantizer:
<span class="hljs-meta">... </span>    q.quantize(save_dir=<span class="hljs-string">&quot;.&quot;</span>,quantization_config=dqconfig)  <span class="hljs-comment"># doctest: +IGNORE_RESULT</span>`}}),{c(){d=s("meta"),T=m(),f=s("h1"),h=s("a"),Q=s("span"),g(_.$$.fragment),H=m(),E=s("span"),S=r("Quantization"),y=m(),w=s("p"),de=r("\u{1F917} Optimum provides an "),Re=s("code"),yt=r("optimum.onnxruntime"),wt=r(` package that enables you to apply quantization on many models hosted on
the Hugging Face Hub using the `),U=s("a"),Tt=r("ONNX Runtime"),Ot=r(`
quantization tool.`),Ge=m(),O=s("p"),bt=r("The quantization process is abstracted via the "),fe=s("a"),xt=r("ORTConfig"),kt=r(` and
the `),he=s("a"),Rt=r("ORTQuantizer"),Qt=r(` classes. The former allows you to specify how quantization should be done,
while the latter effectively handles quantization.`),Ye=m(),g(F.$$.fragment),Je=m(),C=s("h2"),L=s("a"),Qe=s("span"),g(B.$$.fragment),Et=m(),_e=s("span"),St=r("Creating an "),Ee=s("code"),Ct=r("ORTQuantizer"),Ke=m(),b=s("p"),At=r("The "),ge=s("a"),Nt=r("ORTQuantizer"),Mt=r(` class is used to quantize your ONNX model. The class can be initialized using
the `),Se=s("code"),Ft=r("from_pretrained()"),Lt=r(" method, which supports different checkpoint formats."),Ve=m(),qe=s("ol"),G=s("li"),Pt=r("Using an already initialized "),Ce=s("code"),Xt=r("ORTModelForXXX"),Dt=r(" class."),We=m(),g(Y.$$.fragment),Ze=m(),J=s("ol"),Ae=s("li"),It=r("Using a local ONNX model from a directory."),et=m(),g(K.$$.fragment),tt=m(),A=s("h2"),P=s("a"),Ne=s("span"),g(V.$$.fragment),Ht=m(),Me=s("span"),Ut=r("Apply Dynamic Quantization"),at=m(),x=s("p"),Bt=r("The "),ze=s("a"),Gt=r("ORTQuantizer"),Yt=r(` class can be used to quantize dynamically your ONNX model. Below you will
find an easy end-to-end example on how to quantize dynamically
`),W=s("a"),Jt=r("distilbert-base-uncased-finetuned-sst-2-english"),Kt=r("."),nt=m(),g(Z.$$.fragment),st=m(),N=s("h2"),X=s("a"),Fe=s("span"),g(ee.$$.fragment),Vt=m(),Le=s("span"),Wt=r("Static Quantization example"),ot=m(),k=s("p"),Zt=r("The "),ve=s("a"),ea=r("ORTQuantizer"),ta=r(` class can be used to quantize statically your ONNX model. Below you will find
an easy end-to-end example on how to quantize statically
`),te=s("a"),aa=r("distilbert-base-uncased-finetuned-sst-2-english"),na=r("."),it=m(),g(ae.$$.fragment),rt=m(),M=s("h2"),D=s("a"),Pe=s("span"),g(ne.$$.fragment),sa=m(),Xe=s("span"),oa=r("Quantize Seq2Seq models"),lt=m(),R=s("p"),ia=r("The "),$e=s("a"),ra=r("ORTQuantizer"),la=r(` class currently doesn\u2019t support multi-file models, like
`),je=s("a"),pa=r("ORTModelForSeq2SeqLM"),ua=r(`. If you want to quantize a Seq2Seq model, you have to quantize each
model\u2019s component individually.`),pt=m(),g(I.$$.fragment),ut=m(),ye=s("ol"),se=s("li"),ma=r("Load seq2seq model as "),De=s("code"),ca=r("ORTModelForSeq2SeqLM"),da=r("."),mt=m(),g(oe.$$.fragment),ct=m(),ie=s("ol"),Ie=s("li"),fa=r("Define Quantizer for encoder, decoder and decoder with past keys"),dt=m(),g(re.$$.fragment),ft=m(),le=s("ol"),He=s("li"),ha=r("Quantize all models"),ht=m(),g(pe.$$.fragment),this.h()},l(e){const n=nn('[data-svelte="svelte-1phssyn"]',document.head);d=o(n,"META",{name:!0,content:!0}),n.forEach(t),T=c(e),f=o(e,"H1",{class:!0});var ue=i(f);h=o(ue,"A",{id:!0,class:!0,href:!0});var Ue=i(h);Q=o(Ue,"SPAN",{});var ga=i(Q);q(_.$$.fragment,ga),ga.forEach(t),Ue.forEach(t),H=c(ue),E=o(ue,"SPAN",{});var qa=i(E);S=l(qa,"Quantization"),qa.forEach(t),ue.forEach(t),y=c(e),w=o(e,"P",{});var we=i(w);de=l(we,"\u{1F917} Optimum provides an "),Re=o(we,"CODE",{});var za=i(Re);yt=l(za,"optimum.onnxruntime"),za.forEach(t),wt=l(we,` package that enables you to apply quantization on many models hosted on
the Hugging Face Hub using the `),U=o(we,"A",{href:!0,rel:!0});var va=i(U);Tt=l(va,"ONNX Runtime"),va.forEach(t),Ot=l(we,`
quantization tool.`),we.forEach(t),Ge=c(e),O=o(e,"P",{});var Te=i(O);bt=l(Te,"The quantization process is abstracted via the "),fe=o(Te,"A",{href:!0});var $a=i(fe);xt=l($a,"ORTConfig"),$a.forEach(t),kt=l(Te,` and
the `),he=o(Te,"A",{href:!0});var ja=i(he);Rt=l(ja,"ORTQuantizer"),ja.forEach(t),Qt=l(Te,` classes. The former allows you to specify how quantization should be done,
while the latter effectively handles quantization.`),Te.forEach(t),Ye=c(e),q(F.$$.fragment,e),Je=c(e),C=o(e,"H2",{class:!0});var gt=i(C);L=o(gt,"A",{id:!0,class:!0,href:!0});var ya=i(L);Qe=o(ya,"SPAN",{});var wa=i(Qe);q(B.$$.fragment,wa),wa.forEach(t),ya.forEach(t),Et=c(gt),_e=o(gt,"SPAN",{});var _a=i(_e);St=l(_a,"Creating an "),Ee=o(_a,"CODE",{});var Ta=i(Ee);Ct=l(Ta,"ORTQuantizer"),Ta.forEach(t),_a.forEach(t),gt.forEach(t),Ke=c(e),b=o(e,"P",{});var Oe=i(b);At=l(Oe,"The "),ge=o(Oe,"A",{href:!0});var Oa=i(ge);Nt=l(Oa,"ORTQuantizer"),Oa.forEach(t),Mt=l(Oe,` class is used to quantize your ONNX model. The class can be initialized using
the `),Se=o(Oe,"CODE",{});var ba=i(Se);Ft=l(ba,"from_pretrained()"),ba.forEach(t),Lt=l(Oe," method, which supports different checkpoint formats."),Oe.forEach(t),Ve=c(e),qe=o(e,"OL",{});var xa=i(qe);G=o(xa,"LI",{});var qt=i(G);Pt=l(qt,"Using an already initialized "),Ce=o(qt,"CODE",{});var ka=i(Ce);Xt=l(ka,"ORTModelForXXX"),ka.forEach(t),Dt=l(qt," class."),qt.forEach(t),xa.forEach(t),We=c(e),q(Y.$$.fragment,e),Ze=c(e),J=o(e,"OL",{start:!0});var Ra=i(J);Ae=o(Ra,"LI",{});var Qa=i(Ae);It=l(Qa,"Using a local ONNX model from a directory."),Qa.forEach(t),Ra.forEach(t),et=c(e),q(K.$$.fragment,e),tt=c(e),A=o(e,"H2",{class:!0});var zt=i(A);P=o(zt,"A",{id:!0,class:!0,href:!0});var Ea=i(P);Ne=o(Ea,"SPAN",{});var Sa=i(Ne);q(V.$$.fragment,Sa),Sa.forEach(t),Ea.forEach(t),Ht=c(zt),Me=o(zt,"SPAN",{});var Ca=i(Me);Ut=l(Ca,"Apply Dynamic Quantization"),Ca.forEach(t),zt.forEach(t),at=c(e),x=o(e,"P",{});var be=i(x);Bt=l(be,"The "),ze=o(be,"A",{href:!0});var Aa=i(ze);Gt=l(Aa,"ORTQuantizer"),Aa.forEach(t),Yt=l(be,` class can be used to quantize dynamically your ONNX model. Below you will
find an easy end-to-end example on how to quantize dynamically
`),W=o(be,"A",{href:!0,rel:!0});var Na=i(W);Jt=l(Na,"distilbert-base-uncased-finetuned-sst-2-english"),Na.forEach(t),Kt=l(be,"."),be.forEach(t),nt=c(e),q(Z.$$.fragment,e),st=c(e),N=o(e,"H2",{class:!0});var vt=i(N);X=o(vt,"A",{id:!0,class:!0,href:!0});var Ma=i(X);Fe=o(Ma,"SPAN",{});var Fa=i(Fe);q(ee.$$.fragment,Fa),Fa.forEach(t),Ma.forEach(t),Vt=c(vt),Le=o(vt,"SPAN",{});var La=i(Le);Wt=l(La,"Static Quantization example"),La.forEach(t),vt.forEach(t),ot=c(e),k=o(e,"P",{});var xe=i(k);Zt=l(xe,"The "),ve=o(xe,"A",{href:!0});var Pa=i(ve);ea=l(Pa,"ORTQuantizer"),Pa.forEach(t),ta=l(xe,` class can be used to quantize statically your ONNX model. Below you will find
an easy end-to-end example on how to quantize statically
`),te=o(xe,"A",{href:!0,rel:!0});var Xa=i(te);aa=l(Xa,"distilbert-base-uncased-finetuned-sst-2-english"),Xa.forEach(t),na=l(xe,"."),xe.forEach(t),it=c(e),q(ae.$$.fragment,e),rt=c(e),M=o(e,"H2",{class:!0});var $t=i(M);D=o($t,"A",{id:!0,class:!0,href:!0});var Da=i(D);Pe=o(Da,"SPAN",{});var Ia=i(Pe);q(ne.$$.fragment,Ia),Ia.forEach(t),Da.forEach(t),sa=c($t),Xe=o($t,"SPAN",{});var Ha=i(Xe);oa=l(Ha,"Quantize Seq2Seq models"),Ha.forEach(t),$t.forEach(t),lt=c(e),R=o(e,"P",{});var ke=i(R);ia=l(ke,"The "),$e=o(ke,"A",{href:!0});var Ua=i($e);ra=l(Ua,"ORTQuantizer"),Ua.forEach(t),la=l(ke,` class currently doesn\u2019t support multi-file models, like
`),je=o(ke,"A",{href:!0});var Ba=i(je);pa=l(Ba,"ORTModelForSeq2SeqLM"),Ba.forEach(t),ua=l(ke,`. If you want to quantize a Seq2Seq model, you have to quantize each
model\u2019s component individually.`),ke.forEach(t),pt=c(e),q(I.$$.fragment,e),ut=c(e),ye=o(e,"OL",{});var Ga=i(ye);se=o(Ga,"LI",{});var jt=i(se);ma=l(jt,"Load seq2seq model as "),De=o(jt,"CODE",{});var Ya=i(De);ca=l(Ya,"ORTModelForSeq2SeqLM"),Ya.forEach(t),da=l(jt,"."),jt.forEach(t),Ga.forEach(t),mt=c(e),q(oe.$$.fragment,e),ct=c(e),ie=o(e,"OL",{start:!0});var Ja=i(ie);Ie=o(Ja,"LI",{});var Ka=i(Ie);fa=l(Ka,"Define Quantizer for encoder, decoder and decoder with past keys"),Ka.forEach(t),Ja.forEach(t),dt=c(e),q(re.$$.fragment,e),ft=c(e),le=o(e,"OL",{start:!0});var Va=i(le);He=o(Va,"LI",{});var Wa=i(He);ha=l(Wa,"Quantize all models"),Wa.forEach(t),Va.forEach(t),ht=c(e),q(pe.$$.fragment,e),this.h()},h(){u(d,"name","hf:doc:metadata"),u(d,"content",JSON.stringify(pn)),u(h,"id","quantization"),u(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(h,"href","#quantization"),u(f,"class","relative group"),u(U,"href","https://github.com/microsoft/onnxruntime/blob/master/onnxruntime/python/tools/quantization/README.md"),u(U,"rel","nofollow"),u(fe,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.ORTConfig"),u(he,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer"),u(L,"id","creating-an-ortquantizer"),u(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(L,"href","#creating-an-ortquantizer"),u(C,"class","relative group"),u(ge,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer"),u(J,"start","2"),u(P,"id","apply-dynamic-quantization"),u(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(P,"href","#apply-dynamic-quantization"),u(A,"class","relative group"),u(ze,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer"),u(W,"href","https://huggingface.co/distilbert-base-uncased-finetuned-sst-2-english"),u(W,"rel","nofollow"),u(X,"id","static-quantization-example"),u(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(X,"href","#static-quantization-example"),u(N,"class","relative group"),u(ve,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer"),u(te,"href","https://huggingface.co/distilbert-base-uncased-finetuned-sst-2-english"),u(te,"rel","nofollow"),u(D,"id","quantize-seq2seq-models"),u(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(D,"href","#quantize-seq2seq-models"),u(M,"class","relative group"),u($e,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer"),u(je,"href","/docs/optimum/v1.6.4/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModelForSeq2SeqLM"),u(ie,"start","2"),u(le,"start","3")},m(e,n){a(document.head,d),p(e,T,n),p(e,f,n),a(f,h),a(h,Q),z(_,Q,null),a(f,H),a(f,E),a(E,S),p(e,y,n),p(e,w,n),a(w,de),a(w,Re),a(Re,yt),a(w,wt),a(w,U),a(U,Tt),a(w,Ot),p(e,Ge,n),p(e,O,n),a(O,bt),a(O,fe),a(fe,xt),a(O,kt),a(O,he),a(he,Rt),a(O,Qt),p(e,Ye,n),z(F,e,n),p(e,Je,n),p(e,C,n),a(C,L),a(L,Qe),z(B,Qe,null),a(C,Et),a(C,_e),a(_e,St),a(_e,Ee),a(Ee,Ct),p(e,Ke,n),p(e,b,n),a(b,At),a(b,ge),a(ge,Nt),a(b,Mt),a(b,Se),a(Se,Ft),a(b,Lt),p(e,Ve,n),p(e,qe,n),a(qe,G),a(G,Pt),a(G,Ce),a(Ce,Xt),a(G,Dt),p(e,We,n),z(Y,e,n),p(e,Ze,n),p(e,J,n),a(J,Ae),a(Ae,It),p(e,et,n),z(K,e,n),p(e,tt,n),p(e,A,n),a(A,P),a(P,Ne),z(V,Ne,null),a(A,Ht),a(A,Me),a(Me,Ut),p(e,at,n),p(e,x,n),a(x,Bt),a(x,ze),a(ze,Gt),a(x,Yt),a(x,W),a(W,Jt),a(x,Kt),p(e,nt,n),z(Z,e,n),p(e,st,n),p(e,N,n),a(N,X),a(X,Fe),z(ee,Fe,null),a(N,Vt),a(N,Le),a(Le,Wt),p(e,ot,n),p(e,k,n),a(k,Zt),a(k,ve),a(ve,ea),a(k,ta),a(k,te),a(te,aa),a(k,na),p(e,it,n),z(ae,e,n),p(e,rt,n),p(e,M,n),a(M,D),a(D,Pe),z(ne,Pe,null),a(M,sa),a(M,Xe),a(Xe,oa),p(e,lt,n),p(e,R,n),a(R,ia),a(R,$e),a($e,ra),a(R,la),a(R,je),a(je,pa),a(R,ua),p(e,pt,n),z(I,e,n),p(e,ut,n),p(e,ye,n),a(ye,se),a(se,ma),a(se,De),a(De,ca),a(se,da),p(e,mt,n),z(oe,e,n),p(e,ct,n),p(e,ie,n),a(ie,Ie),a(Ie,fa),p(e,dt,n),z(re,e,n),p(e,ft,n),p(e,le,n),a(le,He),a(He,ha),p(e,ht,n),z(pe,e,n),_t=!0},p(e,[n]){const ue={};n&2&&(ue.$$scope={dirty:n,ctx:e}),F.$set(ue);const Ue={};n&2&&(Ue.$$scope={dirty:n,ctx:e}),I.$set(Ue)},i(e){_t||(v(_.$$.fragment,e),v(F.$$.fragment,e),v(B.$$.fragment,e),v(Y.$$.fragment,e),v(K.$$.fragment,e),v(V.$$.fragment,e),v(Z.$$.fragment,e),v(ee.$$.fragment,e),v(ae.$$.fragment,e),v(ne.$$.fragment,e),v(I.$$.fragment,e),v(oe.$$.fragment,e),v(re.$$.fragment,e),v(pe.$$.fragment,e),_t=!0)},o(e){$(_.$$.fragment,e),$(F.$$.fragment,e),$(B.$$.fragment,e),$(Y.$$.fragment,e),$(K.$$.fragment,e),$(V.$$.fragment,e),$(Z.$$.fragment,e),$(ee.$$.fragment,e),$(ae.$$.fragment,e),$(ne.$$.fragment,e),$(I.$$.fragment,e),$(oe.$$.fragment,e),$(re.$$.fragment,e),$(pe.$$.fragment,e),_t=!1},d(e){t(d),e&&t(T),e&&t(f),j(_),e&&t(y),e&&t(w),e&&t(Ge),e&&t(O),e&&t(Ye),j(F,e),e&&t(Je),e&&t(C),j(B),e&&t(Ke),e&&t(b),e&&t(Ve),e&&t(qe),e&&t(We),j(Y,e),e&&t(Ze),e&&t(J),e&&t(et),j(K,e),e&&t(tt),e&&t(A),j(V),e&&t(at),e&&t(x),e&&t(nt),j(Z,e),e&&t(st),e&&t(N),j(ee),e&&t(ot),e&&t(k),e&&t(it),j(ae,e),e&&t(rt),e&&t(M),j(ne),e&&t(lt),e&&t(R),e&&t(pt),j(I,e),e&&t(ut),e&&t(ye),e&&t(mt),j(oe,e),e&&t(ct),e&&t(ie),e&&t(dt),j(re,e),e&&t(ft),e&&t(le),e&&t(ht),j(pe,e)}}}const pn={local:"quantization",sections:[{local:"creating-an-ortquantizer",title:"Creating an `ORTQuantizer`"},{local:"apply-dynamic-quantization",title:"Apply Dynamic Quantization"},{local:"static-quantization-example",title:"Static Quantization example"},{local:"quantize-seq2seq-models",title:"Quantize Seq2Seq models"}],title:"Quantization"};function un(ce){return sn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class hn extends en{constructor(d){super();tn(this,d,un,ln,an,{})}}export{hn as default,pn as metadata};
